## flexc++ 2.07.09

=== debian/changelog ===
flexc++ (2.07.09-1) unstable; urgency=low

  * New upstream release fixes a 0-ptr bug that has been lying hidden in the
    class State causing a segfault with some lexer-specifications. In addition
    several cosmetic changes were made: the parser's tokens were escalated,
    removing circular dependencies between flexc++'s parser and scanner, and
    known typos in the manual were fixed.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Sun, 19 Apr 2020 11:19:54 +0200

flexc++ (2.07.08-1) unstable; urgency=low

  [ Frank B. Brokken ]
  * New upstream release fixes errors in generated files when %interactive
    scanners are generated, and updates the documentation to bisonc++'s new
    token-path option/directive.

  [ tony mancill ]
  * Revert unneeded FORCE_SOURCE_DATE=1 in debian/rules

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Fri, 20 Mar 2020 17:35:52 +0100

=== debian/control ===
Source: flexc++
Section: devel
Priority: optional
Maintainer: Frank B. Brokken <f.b.brokken@rug.nl>
Uploaders: George Danchev <danchev@spnet.net>,
           tony mancill <tmancill@debian.org>
Build-Depends: debhelper-compat (= 12),
 libbobcat-dev (>= 5.04.01),
 icmake (>= 9.03.01),
 yodl (>= 4.02.02)
Standards-Version: 4.5.0
Homepage: https://fbb-git.gitlab.io/flexcpp/
Vcs-Browser: https://salsa.debian.org/debian/flexcpp
Vcs-Git: https://salsa.debian.org/debian/flexcpp.git
Rules-Requires-Root: no

Package: flexc++
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: bisonc++
Description: Flex-style scanner generator for C++
 Flexc++ was designed after `flex'. Flexc++ offers as compared to flex's C++
 option a cleaner class-design.
 .
 Flexc++ generates a scanner class that is ready for use, as well as a member
 function producing the lexical scanner tokens (lex()). The class can easily
 be provided with additional members without the need for polymorphic
 functions. Consequently, classes generated by flexc++ have no virtual members
 and actually have but one public member: lex(), replacing the old-style flex
 and flex++ yylex() function.
 .
 Flexc++ offers many options, among which an option to define classes
 generated by flexc++ in a separate namespace. This allows developers to
 define additional symbols, even outside of the class generated by flexc++,
 without encountering name-collision problems. With flexc++, artificial means
 to prevent name-collisions, like the yy-conventions used by flex and flex++
 are no longer required.  Flexc++ generates C++ code. If C code is required,
 flex should be used. Flexc++'s grammar requirements are highly compatible
 with flex's requirements, so converting a flex grammar into a flexc++ grammar
 should be fairly simple.
 .
 In addition to the flexc++ scanner generator itself and several skeleton
 files, the package contains an extensive man-page, as well as a full manual
 rewritten after the original flex manual, and several examples.

## flexc++ 2.08.01

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Frank B. Brokken <f.b.brokken@rug.nl>
 Uploaders: George Danchev <danchev@spnet.net>,
            tony mancill <tmancill@debian.org>
-Build-Depends: debhelper-compat (= 12),
- libbobcat-dev (>= 5.04.01),
+Build-Depends: debhelper-compat (= 13),
+ libbobcat-dev (>= 5.05.00),
  icmake (>= 9.03.01),
  yodl (>= 4.02.02)
 Standards-Version: 4.5.0

## flexc++ 2.11.00

=== debian/changelog ===
flexc++ (2.11.00-1) unstable; urgency=medium

  * Constructors of generated scanners have received a third parameter,
    'keepCwd = true'. See 'man flexc++api' for details.
  * The build script supports an option 'strip' to strip the binary
    constructed by 'build {program, oxref, scanner}'. The previously defined
    '[strip]' options were dropped.
  * Compilation uses the '--std=c++20' option.
  * The build script is ready for icmake >= 10.00.00
  * Because of the Big Endian / Little Endian issue with icmake, 'control'
    requires icmake >= 10.03.00

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Tue, 22 Feb 2022 13:30:22 +0100

flexc++ (2.10.00-2) unstable; urgency=medium

  * Upload to unstable
  * Bump Standards-Version to 4.6.0

 -- tony mancill <tmancill@debian.org>  Thu, 09 Sep 2021 20:19:03 -0700

flexc++ (2.10.00-1) experimental; urgency=low

  * Version 2.10 declares user-defined nested ScannerBase::Input classes in
    ScannerBase's protected sections so they can be used from inside the
    derived Scanner classes.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Thu, 22 Apr 2021 15:08:01 +0200

flexc++ (2.09.01-1) experimental; urgency=low

  * Upstream added sections about character constants to the manual and to the
    flexc++input(7) man-page

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Fri, 19 Mar 2021 09:34:44 +0100

flexc++ (2.09.00-1) experimental; urgency=low

  [ Frank B. Brokken ]
  * The initial working directory is kept after constructing Scanner objects
    and when their member 'lex()' returns.

  * Added member 'cwd()' returning the directory that was active when
    constructing a Scanner object.

  [ tony mancill ]
  * Upload to experimental during Bullseye freeze.
  * Freshen debian/copyright

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Sun, 21 Feb 2021 12:23:23 +0100

flexc++ (2.08.01-1) unstable; urgency=low

  * Fixed a bug in handling the //include directive

  * Pushing/popping streams changes the scanner's current working directory to
    the streams' directories.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Fri, 13 Nov 2020 16:05:09 +0100

flexc++ (2.07.11-1) unstable; urgency=low

  * Manual chapters in version 2.07.10 beyond the introductory chapter were
    missing. Fixed in this release.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Sun, 30 Aug 2020 15:16:06 +0200

flexc++ (2.07.10-1) unstable; urgency=low

  * New upstream release fixed a flaw in the man(ual)'s section about using
    bisonc++ in combination with flexc++.

  * updated debian/control's debhelper-compat to 13, libbobcat-dev to 5.05.00.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Sun, 30 Aug 2020 14:03:20 +0200

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Uploaders: George Danchev <danchev@spnet.net>,
            tony mancill <tmancill@debian.org>
 Build-Depends: debhelper-compat (= 13),
- libbobcat-dev (>= 5.05.00),
+ libbobcat-dev (>= 5.07.02),
  icmake (>= 9.03.01),
  yodl (>= 4.02.02)
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://fbb-git.gitlab.io/flexcpp/
 Vcs-Browser: https://salsa.debian.org/debian/flexcpp
 Vcs-Git: https://salsa.debian.org/debian/flexcpp.git

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export DEB_BUILD_HARDENING = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)

export LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
export LDFLAGS += -Wl,-z,now

export CXXFLAGS = $(shell dpkg-buildflags --get CXXFLAGS)
export CXXFLAGS += --std=c++20 -Wall -D_FORTIFY_SOURCE=2

export CXX = g++

SKEL = /usr/share/flexc++

%:
	dh $@

override_dh_auto_clean:
	./build clean
	dh_auto_clean

override_dh_auto_build:
	# compile the package.
	./build program
	./build man
	./build manual
	dh_auto_build -a

override_dh_auto_install:
	# Add here commands to install the package into debian/flexc++.
	./build install x debian/flexc++
	dh_installdocs README.class-setup flexc++.xref
	dh_auto_install

print-version:
	@@echo "Debian version:                  $(DEBVERSION)"
	@@echo "Upstream version:                $(UPVERSION)"

## flexc++ 2.11.01

=== debian/changelog ===
flexc++ (2.11.01-1) unstable; urgency=medium

  * Upstream repaired some flaws in the generated flex.cc source that might
    result in compilation errors, prevented segfaults from occurring when
    specifying some overly complex regexes. See the upstream changelog for
    details.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Tue, 23 Aug 2022 21:14:55 +0200

flexc++ (2.11.00-2) unstable; urgency=medium

  * Add autopkgtest that uses to flexc++ to create a basic scanner.

 -- tony mancill <tmancill@debian.org>  Sun, 27 Feb 2022 12:19:34 -0800

## flexc++ 2.11.02

=== documentation/manual/Makefile ===
.PHONY: all clean

all: flexc++.pdf flexc++.html

clean:
	rm flexc++*.html flexc++.{aux,latex,log,pdf,toc}

flexc++.html: *.yo
	yodl2html flexc++

flexc++.pdf: *.yo
	yodl2latex flexc++
	pdflatex flexc++.latex
	pdflatex flexc++.latex

=== debian/changelog ===
flexc++ (2.11.02-1) unstable; urgency=medium

  [ Frank B. Brokken ]
  * New upstream version 2.11.02
  * debian/rules determines the C++ version to use from upstream's 'c++std'
    file

  [ Debian Janitor <janitor@jelmer.uk> ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Sun, 11 Sep 2022 21:04:23 +0200

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  libbobcat-dev (>= 5.07.02),
  icmake (>= 9.03.01),
  yodl (>= 4.02.02)
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://fbb-git.gitlab.io/flexcpp/
 Vcs-Browser: https://salsa.debian.org/debian/flexcpp
 Vcs-Git: https://salsa.debian.org/debian/flexcpp.git

=== debian/rules ===
--- 
+++ 
@@ -6,19 +6,21 @@
 # dh-make output file, you may use that output file without restriction.
 # This special exception was added by Craig Small in version 0.37 of dh-make.
 
-# Uncomment this to turn on verbose mode.
+# Uncommented to turn on verbose mode.
 export DH_VERBOSE=1
 
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 export DEB_BUILD_HARDENING = 1
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 export CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)
 
-export LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
-export LDFLAGS += -Wl,-z,now
+export CXXFLAGS = $(shell dpkg-buildflags --get CXXFLAGS)
+export CXXFLAGS += -Wall -D_FORTIFY_SOURCE=2
 
-export CXXFLAGS = $(shell dpkg-buildflags --get CXXFLAGS)
-export CXXFLAGS += --std=c++20 -Wall -D_FORTIFY_SOURCE=2
+# Define the c++std to use by processing the upstream 'c++std' file
+export CXXFLAGS += $(shell cat c++std|sed -e 's/#define CPPSTD "//' -e 's/"//')
+
+export LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS) -Wl,-z,now
 
 export CXX = g++

## flexc++ 2.14.00

=== debian/changelog ===
flexc++ (2.14.00-2) unstable; urgency=medium

  * Upload to unstable

 -- tony mancill <tmancill@debian.org>  Sun, 11 Jun 2023 15:31:44 -0700

flexc++ (2.14.00-1) experimental; urgency=medium

  * New upstream release replaces 'typedef' definitions by 'using'
    declarations, also in generated scanners.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Thu, 23 Mar 2023 10:31:14 +0100

flexc++ (2.13.00-1) experimental; urgency=medium

  * New upstream release uses inline definitions of the default class Input
    members which previously were defined in-class.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Thu, 16 Mar 2023 11:29:19 +0100

flexc++ (2.12.00-1) experimental; urgency=medium

  * New upstream release defines new option --baseclass-preinclude and new
    options %baseclass-preinclude and %input-inline.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Fri, 10 Mar 2023 15:23:00 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  libbobcat-dev (>= 5.07.02),
  icmake (>= 9.03.01),
  yodl (>= 4.02.02)
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://fbb-git.gitlab.io/flexcpp/
 Vcs-Browser: https://salsa.debian.org/debian/flexcpp
 Vcs-Git: https://salsa.debian.org/debian/flexcpp.git

## flexc++ 2.15.00

=== debian/changelog ===
flexc++ (2.15.00-1) unstable; urgency=medium

  * New upstream release fixes a bug that appeared when regexes like a{2} were
    used as the first specified regex in the lexer file

  * Icmake >= 11.01.02 is used when building flexc++

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Sat, 23 Mar 2024 13:55:32 +0100

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Uploaders: George Danchev <danchev@spnet.net>,
            tony mancill <tmancill@debian.org>
 Build-Depends: debhelper-compat (= 13),
- libbobcat-dev (>= 5.07.02),
- icmake (>= 9.03.01),
+ libbobcat-dev (>= 6.02.02),
+ icmake (>= 11.01.02),
  yodl (>= 4.02.02)
 Standards-Version: 4.6.2
 Homepage: https://fbb-git.gitlab.io/flexcpp/

## flexc++ 2.16.00

=== debian/changelog ===
flexc++ (2.16.00-1) unstable; urgency=medium

  * New upstream release fixes a bug in the scanner switchIstream protected
    member function.
  * Icmake >= 12.01.00 is used when building flexc++.
  * The control file now specifies Standards-Version 4.7.0.

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Sat, 22 Jun 2024 16:24:58 +0200

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,9 @@
            tony mancill <tmancill@debian.org>
 Build-Depends: debhelper-compat (= 13),
  libbobcat-dev (>= 6.02.02),
- icmake (>= 11.01.02),
+ icmake (>= 12.01.00),
  yodl (>= 4.02.02)
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://fbb-git.gitlab.io/flexcpp/
 Vcs-Browser: https://salsa.debian.org/debian/flexcpp
 Vcs-Git: https://salsa.debian.org/debian/flexcpp.git

=== debian/rules ===
--- 
+++ 
@@ -12,13 +12,12 @@
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 export DEB_BUILD_HARDENING = 1
 
+export ICMAKE_CPPSTD = --std=c++23
+
 export CPPFLAGS = $(shell dpkg-buildflags --get CPPFLAGS)
 
 export CXXFLAGS = $(shell dpkg-buildflags --get CXXFLAGS)
 export CXXFLAGS += -Wall -D_FORTIFY_SOURCE=2
-
-# Define the c++std to use by processing the upstream 'c++std' file
-export CXXFLAGS += $(shell cat c++std|sed -e 's/#define CPPSTD "//' -e 's/"//')
 
 export LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS) -Wl,-z,now

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, bash, shunit2, g++, libbobcat-dev
Restrictions: allow-stderr

## flexc++ 2.17.00

=== debian/changelog ===
flexc++ (2.17.00-1) unstable; urgency=medium

  [ Frank B. Brokken ]
  * New upstream release (Closes: #1099490)
  * Flexc++ depends on bobcat >= 6.07.00 and icmake >= 13.00.03
  * Updated debian/copyright, debian/control, and debian/rules

 -- tony mancill <tmancill@debian.org>  Tue, 04 Mar 2025 08:10:56 -0800

## flexc++ 2.17.01

=== debian/changelog ===
flexc++ (2.17.01-1) unstable; urgency=medium

  * New upstream release prevents errors when using string::back() with
    empty strings (introduced by g++ >= 15.0.0).

 -- Frank B. Brokken <f.b.brokken@rug.nl>  Thu, 06 Mar 2025 13:12:19 +0100

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,11 @@
 Section: devel
 Priority: optional
 Maintainer: Frank B. Brokken <f.b.brokken@rug.nl>
-Uploaders: George Danchev <danchev@spnet.net>,
-           tony mancill <tmancill@debian.org>
+Uploaders: tony mancill <tmancill@debian.org>
 Build-Depends: debhelper-compat (= 13),
- libbobcat-dev (>= 6.02.02),
- icmake (>= 12.01.00),
- yodl (>= 4.02.02)
+                libbobcat-dev (>= 6.07.00),
+                icmake (>= 13.00.03),
+                yodl (>= 4.03.03)
 Standards-Version: 4.7.0
 Homepage: https://fbb-git.gitlab.io/flexcpp/
 Vcs-Browser: https://salsa.debian.org/debian/flexcpp

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export ICMAKE_CPPSTD = --std=c++26

# Uncommented to turn on verbose mode.
export DH_VERBOSE=1

export DEB_BUILD_HARDENING=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export CXXFLAGS = $(shell dpkg-buildflags --get CXXFLAGS)
export CXXFLAGS += ${ICMAKE_CPPSTD}  -Wall -D_FORTIFY_SOURCE=2

export LDFLAGS = $(shell dpkg-buildflags --get LDFLAGS)
export LDFLAGS += -Wl,-z,now

# tell texlive to respect SOURCE_DATE_EPOCH for reproducible builds
export FORCE_SOURCE_DATE=1

export CXX = g++

SKEL = /usr/share/flexc++

%:
	dh $@

override_dh_clean:
	./build clean
	dh_clean

override_dh_auto_build:
	./build program
	./build man
	./build manual

override_dh_install:
	./build install x debian/flexc++
	dh_installdocs README.class-setup flexc++.xref

=== debian/watch ===
version=4
opts=filenamemangle=s/.*-([\d.]+)\.tar\.gz/flexc++-$1\.tar\.gz/g \
    https://gitlab.com/fbb-git/flexcpp/tags \
        \/fbb-git\/flexcpp\/-\/archive\/[\d.]*\/flexcpp-([\d.]*)\.tar\.gz
